# # What is printed?
# numbers = []
# numbers.append(7)
# numbers.append(3)
# numbers.sort()
# print(len(numbers))
# 
# # What is printed?
# numbers = []
# numbers.append(7)
# numbers.append(3)
# numbers.sort()
# numbers[-1] = 10
# print(numbers)

# --------------------------------------------------------------------------------------------------
# Example: first letters of strings

def first_letters(strings):
    """
    Returns a list containing the first letters of each string

    Arguments:
        strings (List[str]): the strings

    Returns:
        List[str]: a list of strings containing only the first letters
    """
    firsts = []
    for s in strings:
        print("Before append:", firsts, s, s[0])
        firsts.append(s[0])
        print("After append:", firsts, s, s[0])
    return firsts

# print(first_letters(["hello", "world"]))

# --------------------------------------------------------------------------------------------------
# Exercise: change this code to get the last letters of a string

def last_letters(strings):
    """
    Returns a list containing the last letters of each string

    Arguments:
        strings (List[str]): the strings

    Returns:
        List[str]: a list of strings containing only the last letters
    """
    lasts = []
    for s in strings:
        lasts.append(s[-1])
    return lasts

# print(last_letters(["hello", "world"]))

# --------------------------------------------------------------------------------------------------
# Example: names that start with "L"

def filter_names_l(names):
    """
    Returns a list containing only names the start with L

    Arguments:
        strings (List[str]): the names

    Returns:
        List[str]: a list of names that start with L
    """
    new_names = []
    for name in names:
        if name[0] == "L":
            new_names.append(name)
    return new_names

# print(filter_names_l(["Laura", "Lucy", "James", "Luke", "Karen"]))

# --------------------------------------------------------------------------------------------------
# Example: Average of Numbers in a list
# create a list of numbers
numbers = [17, 6, 64, 25, 4]

# get the sum of numbers in the list
number_sum = 0
for number in numbers:
    number_sum = number_sum + number

# divide by number of items for the average
average = number_sum / len(numbers)
# print(average)


# --------------------------------------------------------------------------------------------------
# Example: maximum number in a list of positive numbers
# create a list of numbers
numbers = [17, 6, 64, 25, 4]

max_number = 0
for number in numbers:
    # update max_number if the current number is higher
    if number > max_number:
        max_number = number
    
# once we reach the end of the loop, max_number is the highest number in the list
# print(max_number)


